unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, BGRAAnimatedGif,
  BGRAGraphicControl, FPWriteGIF, BGRABitmap, BGRABitmapTypes;

type

  { TForm1 }

  TForm1 = class(TForm)
    BGRAGraphicControl1: TBGRAGraphicControl;
    bnConvert: TButton;
    procedure bnConvertClick(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.bnConvertClick(Sender: TObject);
  var
  img: TBGRABitmap;
  gif: TBGRAAnimatedGif;
  i, delayms: integer;
  ms: TMemoryStream;
  gifw: TFPWriterGIF;
begin
  delayms := 100;
  gif := TBGRAAnimatedGif.Create;
  gif.SetSize(709, 709);
  gif.LoopCount := 0;  //endless loop
  ms := TMemoryStream.Create;
  gifw := TFPWriterGIF.Create;

  for i := 0 to 2 do
  begin
    img := TBGRABitmap.Create(Format('frame%d.png', [i]));
    //save as gif with fpwritergif
    img.SaveToStream(ms, gifw);
    ms.Position := 0;
    img.Free;
    img := TBGRABitmap.Create(ms);
    //add frame
    gif.AddFullFrame(img, delayms);
    img.Free;
    ms.Clear;
  end;
  gifw.Free;
  ms.Free;
  gif.OptimizeFrames;
  gif.SaveToFile('sample-ani-2.gif'); //save to file
  gif.Free; //clean
end;

end.

